import sys
import os
picdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'pic')
libdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'lib')
if os.path.exists(libdir):
    sys.path.append(libdir)

import logging

import epd1in9
import time
import IIC
import RPi.GPIO as GPIO
import os


DSPNUM_WB = [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF]  # black
DSPNUM_WW = [0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00]  # white
DSPNUM_WB = [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF]  # All black font
DSPNUM_W0 = [0x00, 0xbf, 0x1f, 0xbf, 0x1f, 0xbf, 0x1f, 0xbf, 0x1f, 0xbf, 0x1f, 0xbf, 0x1f, 0x00, 0x00]  # 0
DSPNUM_W1 = [0xff, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x00, 0x00]  # 1
DSPNUM_W2 = [0x00, 0xfd, 0x17, 0xfd, 0x17, 0xfd, 0x17, 0xfd, 0x17, 0xfd, 0x17, 0xfd, 0x37, 0x00, 0x00]  # 2
DSPNUM_W3 = [0x00, 0xf5, 0x1f, 0xf5, 0x1f, 0xf5, 0x1f, 0xf5, 0x1f, 0xf5, 0x1f, 0xf5, 0x1f, 0x00, 0x00]  # 3
DSPNUM_W4 = [0x00, 0x47, 0x1f, 0x47, 0x1f, 0x47, 0x1f, 0x47, 0x1f, 0x47, 0x1f, 0x47, 0x3f, 0x00, 0x00]  # 4
DSPNUM_W5 = [0x00, 0xf7, 0x1d, 0xf7, 0x1d, 0xf7, 0x1d, 0xf7, 0x1d, 0xf7, 0x1d, 0xf7, 0x1d, 0x00, 0x00]  # 5
DSPNUM_W6 = [0x00, 0xff, 0x1d, 0xff, 0x1d, 0xff, 0x1d, 0xff, 0x1d, 0xff, 0x1d, 0xff, 0x3d, 0x00, 0x00]  # 6
DSPNUM_W7 = [0x00, 0x21, 0x1f, 0x21, 0x1f, 0x21, 0x1f, 0x21, 0x1f, 0x21, 0x1f, 0x21, 0x1f, 0x00, 0x00]  # 7
DSPNUM_W8 = [0x00, 0xff, 0x1f, 0xff, 0x1f, 0xff, 0x1f, 0xff, 0x1f, 0xff, 0x1f, 0xff, 0x3f, 0x00, 0x00]  # 8
DSPNUM_W9 = [0x00, 0xf7, 0x1f, 0xf7, 0x1f, 0xf7, 0x1f, 0xf7, 0x1f, 0xf7, 0x1f, 0xf7, 0x1f, 0x00, 0x00]  # 9

number_0 = [0xbf, 0x1f]
number_1 = [0x1f, 0x00]
number_2 = [0xfd, 0x17]
number_3 = [0xf5, 0x1f]
number_4 = [0x47, 0x1f]
number_5 = [0xf7, 0x1d]
number_6 = [0xff, 0x1d]
number_7 = [0x21, 0x1f]
number_8 = [0xff, 0x1f]
number_9 = [0xf7, 0x1f]
number = [[0xbf, 0x1f], [0x1f, 0x00], [0xfd, 0x17], [0xf5, 0x1f], [0x47, 0x1f], [0xf7, 0x1d], [0xff, 0x1d], [0x21, 0x1f], [0xff, 0x1f], [0xf7, 0x1f]]
radix_point = 0x20
degree_centigrad = 0x05
Fahrenheit_degree = 0x06
BLE = 0x08
POW = 0x10
First_black = 0x1f
First_white = 0x00



try:
    
    logging.info("epd1in9 Demo")
    
    epd = epd1in9.EPD()
    logging.info("init and Clear")
    
    epd.init()
    
    epd.lut_5S()
    print("1111")
    epd.Write_Screen(DSPNUM_WW)
    
    time.sleep(0.5)
    
    
    epd.lut_GC()
    epd.Write_Screen1(DSPNUM_WB)
    time.sleep(0.5)
    epd.Write_Screen(DSPNUM_WW)
    time.sleep(0.5)

    
    
    epd.lut_DU_WB()
    time.sleep(0.5)
    epd.Write_Screen(DSPNUM_W0);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W1);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W2);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W3);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W4);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W5);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W6);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W7);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W8);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_W9);
    time.sleep(0.5)	
    epd.Write_Screen(DSPNUM_WB)
    time.sleep(0.5)

    
    # epd.send_command(0xe1)
    # epd.send_command(0xe5)
    # epd.send_command(0x73)
    # epd.send_command(0xB6)
    # time.sleep(0.1)
    
    # a = (epd.read_com(0xe4)>>1)
    # print(a)


    epd.sleep()








# except IOError as e:
    # print("aaaa")
    # logging.info(e)
    
except KeyboardInterrupt: 
    print("BBBB")
    logging.info("ctrl + c:")
    IIC.module_exit()
    exit()






